/**
 * A brief explanation for "project.json":
 * Here is the content of project.json file, this is the global configuration for your game, you can modify it to customize some behavior.
 * The detail of each field is under it.
 {
    "project_type": "javascript",
    // "project_type" indicate the program language of your project, you can ignore this field

    "debugMode"     : 1,
    // "debugMode" possible values :
    //      0 - No message will be printed.
    //      1 - cc.error, cc.assert, cc.warn, cc.log will print in console.
    //      2 - cc.error, cc.assert, cc.warn will print in console.
    //      3 - cc.error, cc.assert will print in console.
    //      4 - cc.error, cc.assert, cc.warn, cc.log will print on canvas, available only on web.
    //      5 - cc.error, cc.assert, cc.warn will print on canvas, available only on web.
    //      6 - cc.error, cc.assert will print on canvas, available only on web.

    "showFPS"       : true,
    // Left bottom corner fps information will show when "showFPS" equals true, otherwise it will be hide.

    "frameRate"     : 60,
    // "frameRate" set the wanted frame rate for your game, but the real fps depends on your game implementation and the running environment.

    "noCache"       : false,
    // Set "noCache" to true can make the loader ignoring the html page cache while loading your resources, 
    // especially useful in Android web browsers.

    "id"            : "gameCanvas",
    // "gameCanvas" sets the id of your canvas element on the web page, it's useful only on web.

    "renderMode"    : 0,
    // "renderMode" sets the renderer type, only useful on web :
    //      0 - Automatically chosen by engine
    //      1 - Forced to use canvas renderer
    //      2 - Forced to use WebGL renderer, but this will be ignored on mobile browsers

    "engineDir"     : "frameworks/cocos2d-html5/",
    // In debug mode, if you use the whole engine to develop your game, you should specify its relative path with "engineDir",
    // but if you are using a single engine file, you can ignore it.

    "modules"       : ["cocos2d"],
    // "modules" defines which modules you will need in your game, it's useful only on web,
    // using this can greatly reduce your game's resource size, and the cocos console tool can package your game with only the modules you set.
    // For details about modules definitions, you can refer to "../../frameworks/cocos2d-html5/modulesConfig.json".

    "jsList"        : [
    ]
    // "jsList" sets the list of js files in your game.
 }
 *
 */
if(typeof TagOfLayer == "undefined") {
    var TagOfLayer = {};
    TagOfLayer.bgLayer = 0;
    TagOfLayer.callPadLayer = 1;
    TagOfLayer.cardsLayer = 2;
};
cc.game.onStart = function(){
    if(!cc.sys.isNative && document.getElementById("cocosLoading")) //If referenced loading.js, please remove it
        document.body.removeChild(document.getElementById("cocosLoading"));

    // Pass true to enable retina display, on Android disabled by default to improve performance
    cc.view.enableRetina(cc.sys.os === cc.sys.OS_IOS ? true : false);
    // Adjust viewport meta
    cc.view.adjustViewPort(true);
    
    
    // Setup the resolution policy and design resolution size
    cc.view.setDesignResolutionSize(1024, 600, cc.ResolutionPolicy.FIXED_WIDTH);
    // Instead of set design resolution, you can also set the real pixel resolution size
    // Uncomment the following line and delete the previous line.
    // cc.view.setRealPixelResolution(960, 640, cc.ResolutionPolicy.SHOW_ALL);
    // The game will be resized when browser size change
    cc.view.resizeWithBrowserSize(true);

    winSize = cc.director.getWinSize();
//    cc.log("----------cc.game.onStart>winSize "+winSize.width +" "+ winSize.height);
    visibleSize = cc.director.getVisibleSize();
    origin = cc.director.getVisibleOrigin();
    
    if(winSize.height<400){
        btnYpos = visibleSize.height-90;
    }else if(winSize.height>=400 && winSize.height<720){
        btnYpos = visibleSize.height-105;
    }else{
        btnYpos = visibleSize.height-130;
    }
    
    cc.log("--------------winSize.height: "+winSize.height + "  visibleSize.height: "+visibleSize.height + " btnYpos: "+btnYpos);
    
    //load resources
    cc.LoaderScene.preload(g_resources, function () {
      loadSettings();
      cc.director.runScene(new MainMenuScene());
        
//      cc.log("---------sdkbox.PluginLeadBolt "+sdkbox.PluginLeadBolt);
        
       setTimeout(function(){
           sdkbox.PluginAdMob.init();
//           sdkbox.PluginAdMob.setTestDevices("e462be553ab218629a1d5bab08b15644");
//           sdkbox.PluginAdMob.setTestDevices("kGADSimulatorID");
//            sdkbox.PluginAdMob.cache("top_banner");
          //       sdkbox.PluginReview.setTitle("Call Break++");
           //       sdkbox.PluginReview.setMessage("If you enjoy this game, would you mind taking a moment to rate it? It won't take more than a minute. Thanks for your support.");
           //       sdkbox.PluginReview.setCancelButtonTitle("custom cancel");
           //       sdkbox.PluginReview.setRateButtonTitle("custom rate");
           //       sdkbox.PluginReview.setRateLaterButtonTitle("custom rate later");
           //        sdkbox.PluginReview.init();
           
          },500);
                           
//           setTimeout(function(){
//                      sdkbox.PluginApteligent.init();
          //           var userId = sdkbox.PluginApteligent.getUserUUID();
          //           sdkbox.PluginApteligent.setUsername(userId);
          //           sdkbox.PluginApteligent.beginUserflow(userId);
          // perform all breadcrumb writes on a background thread
          //           sdkbox.PluginApteligent.setAsyncBreadcrumbMode(true);
          
          //       sdkbox.PluginReview.setTitle("Call Break++");
          //       sdkbox.PluginReview.setMessage("If you enjoy this game, would you mind taking a moment to rate it? It won't take more than a minute. Thanks for your support.");
          //       sdkbox.PluginReview.setCancelButtonTitle("custom cancel");
          //       sdkbox.PluginReview.setRateButtonTitle("custom rate");
          //       sdkbox.PluginReview.setRateLaterButtonTitle("custom rate later");
          //        sdkbox.PluginReview.init();
          
//          },1500);
                           
//           setTimeout(function(){
//                      sdkbox.PluginLeadBolt.init();
//            },3000);
    }, this);
};
cc.game.run();