/**
 * Created by user on 10/9/14.
 */
var Player = cc.Class.extend({
    cardCount:null,
    cards:null,
    startPos:null,
    id:null,
    bidVal:null,
    hands:null,
    name:null,
    ctor:function(_startPos, _id){
        this.startPos = _startPos;
        this.id = _id;

        this.cardCount = 0;
        this.cards = [];
        this.hands = 0;
        this.bidVal = 0;
        return true;
    },
    sortCards:function(){
//        cc.log("sortCards");
        // sorting cards according to suits and values
        sortCardsArr(this.cards);
//        this.cards.reverse();
    },
    getCard:function(param){
        //--- AI part, calculation of the new card to be thrown for the game play --
        //--1: finding greater card by current led suit
        //--2: if greater is not available then get smallest
        //--3: if player doesn't have card of current suit then get smallest spades card first
        //--4: if spades card is already thrown then get greater card of spades
        //--5: if greater spade card is not available, get smallest spades card first
        //--6: if no spade card is remained then throw smallest random card
        //--7: finding greater card by current led suit
    	//--8: if a player has cards of current led suit but spade has been moved by other player then he can move smallest card of that led suit.
        //--9: if greater is not available then get smallest

    	var card;
    	var refThis = this;
//    	cc.log("getCard>param "+ typeof param);
    	
    	// if param is boolean it's for random card
    	// if param is object then it's selected card by the user
    	// else greater card than current led card
    	if(typeof param == 'number'){
    		card = this.cards[0];
//    		cc.log("getCard>card 0 "+card);
    	}else if(typeof param == 'boolean'){
    		// value is always true and it's called when it's bot player's turn and it is first card to throw (leading card)
    		card = this.getRandomCard();
//    		cc.log("getCard>card 1"+card);
    	}else if(typeof param == 'object'){
    		card = this.cards[this.cards.indexOf(param)]; 
//    		cc.log("getCard>card 2"+card);
    	}else{
    		// above --9 rule is implemented here.
    		var maxCard = getMaxCardBySuit(curCardMove.suit, cardsOnFloor);
    		// if current lead suit is Trump
    		if(curCardMove.suit == Suits.Trump){
    			// if it's last/forth turn
    			if(cardsOnFloor.length == 3)
    			{
    				card = getMaxCardsThan(maxCard, this.cards, true)[0];
    				if(card == undefined){
    					card = this.getMinCardBySuit(curCardMove.suit);
    				}
//    				cc.log("getCard>card 4 "+ card.suit+ " " + card.value);
    			}else{
    				//if it's not last turn, it can be 2nd or 3rd
    				// checking if Ace is been used already 
    				if(hasAce(curCardMove.suit, cardsOnFloor)){
    					// if Ace is been used throw a smaller card
    					card = this.getMinCardBySuit(curCardMove.suit);
    				}else{    					
    					if(hasAce(curCardMove.suit, this.cards))
						{
    						// if the player has Ace but Ace is been not used yet
    						// use logic in v1.2 below in case of it's not trump card
    						pickAceRandomly();
						}else if(hasFaceCards(curCardMove.suit, this.cards)){
							// doesn't have Ace but have more than 1 face cards
							// check if Ace is been thrown already before
							var thrownCards = getCardsBySuit(curCardMove.suit, thrownCardsArr);
							// card J=9, Q=10, K=11, A=12
							// if Ace is been thrown already before then throw max avaialble card
							if(hasCard(curCardMove.suit, 12, thrownCards))
							{
								card = getMaxCardBySuit(curCardMove.suit, this.cards);
							}else if(hasCard(curCardMove.suit, 11, thrownCards)){
								// if ace is not been thrown before then check for King if it's thrown, if yes then throw max card
								card = getMaxCardBySuit(curCardMove.suit, this.cards);
							}else{
								// if there's no ace or king thrown before then get max cards than current on the floor/table
								card = getMaxCardsThan(maxCard, this.cards, true)[0];
							}
						}
    				}
//    				card = getLastMaxCardBySuit(curCardMove.suit, this.cards);
    				if(card != undefined){
//    					cc.log("-------------------getCard>card 5 "+card.suit+ " " + card.value);
    				}else{
    					card = getMaxCardsThan(maxCard, this.cards, true)[0];
    					if(card == undefined){
    						card = this.getMinCardBySuit(curCardMove.suit);
//    						cc.log("getCard>card 6 "+ card.suit+ " " + card.value);
    					}else{
//    						cc.log("getCard>card 6.1 "+ card.suit+ " " + card.value);
    					}
    				}
    			}
    		}else{
	    		if(hasTrump(cardsOnFloor)){
	    			card = this.getMinCardBySuit(curCardMove.suit);
	//    			cc.log("getCard>card 3"+card);
	    		}else{
	    			if(cardsOnFloor.length == 3)
	    			{
	    				card = getMaxCardsThan(maxCard, this.cards, true)[0];
	    				if(card == undefined){
	    					card = this.getMinCardBySuit(curCardMove.suit);
	    				}
//	    				cc.log("getCard>card 7 "+ card.suit+ " " + card.value);
	    			}else{
	    			    // v1.2 code
//	    				var maxCard = getMaxCardBySuit(curCardMove.suit, cardsOnFloor);
	    				pickAceRandomly();
	    				if(card != undefined){
//	    					cc.log("-------------------getCard>card 8 "+card.suit+ " " + card.value);
	    				}else{
	    					var maxCard = getMaxCardBySuit(curCardMove.suit, cardsOnFloor);
	//  					cc.log("getCard>card 4.0 "+maxCard.suit+ " " + maxCard.value);
	
	    					card = getMaxCardsThan(maxCard, this.cards, true)[0];
	
	    					if(card == undefined){
	    						card = this.getMinCardBySuit(curCardMove.suit);
//	    						cc.log("-------------------getCard>card 9 "+card.suit+ " " + card.value);
	    					}else{
//	    						cc.log("-------------------getCard>card 9.1 "+card.suit+ " " + card.value);
	    					}
	    				}
	    			}
	    		}
    		}
    	}
    	
        //--3: if player doesn't have card of current suit then get smallest spades card first
        //--4: if spades card is already thrown then get greater card of spades
        //--5: if greater spade card is not available, get smallest spades card first

        if(card == undefined){
            card = this.getMinCardBySuit(Suits.Trump);
//            cc.log("getCard>card 10 "+card.suit+ " " + card.value);
        }

        // if the player doesn't have card of current suit and spades either, then random card will be thrown
        //--6: if no spade card is remained then throw smallest random card

        if(card == undefined){
            card = this.getRandomCard();
//            cc.log("getCard>card 11 "+card.suit+ " " + card.value);
        }

        this.cards.splice(this.cards.indexOf(card), 1);
//        cc.log("getCard "+ card.suit+ " " + card.value + " id: " + this.id);
        
        // nested function 
        function pickAceRandomly()
        {
        	// checking max card on the floor, if max card is less than 6 and user has an ace then not to throw ace always, throw ace randomly or last max card, K in case user has both K and A
        	if(maxCard.value<5)
        	{
        		if(hasAce(curCardMove.suit, refThis.cards)){
        			// generating random num with probability, probability of throwing Ace is double
        			var weightedRandArr = [1,1,1,1,0,0];
        			var rnd = weightedRandArr[Math.round(Math.random()*weightedRandArr.length)];
        			var throwAce = rnd==1?true:false;
        			// forcing to throw ace if throwcount is greater than 4 and user has the ace
        			// keeping ace for longer time will result loss, other player will use trump to break it
        			if(throwCount>4)
        			{
        				throwAce = true;
        			}
        			
        			if(throwAce){
        				//throwing the ace card randomly
        				card = getLastMaxCardBySuit(curCardMove.suit, refThis.cards);
        			}else{
        				//checking if greater card is available, if greater card is not available and ace is available then ace will be thrown
        				card = getMaxCardsThan(maxCard, refThis.cards, true)[0];
//      				cc.log("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@getCard>card 8 "+ card.suit+ " " + card.value + " throwAce "+ throwAce + " rnd "+rnd) ;
        				if(card == undefined){
        					card = getLastMaxCardBySuit(curCardMove.suit, refThis.cards);
        				}
//      				cc.log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~getCard>card 9 "+ card.suit+ " " + card.value + " throwAce "+ throwAce + " rnd "+rnd) ;
        			}
//      			cc.log("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@getCard>card 9 "+ card.suit+ " " + card.value + " throwAce "+ throwAce + " rnd "+rnd) ;
        		}else{
        			card = getMaxCardsThan(maxCard, refThis.cards, true)[0];
        		}
        	}else{
        		card = getLastMaxCardBySuit(curCardMove.suit, refThis.cards);
        	}
        }
        return card;
    },
    getMinCardBySuit:function(suit){
        var i, card;
        var minCard = this.cards[0];
        var minCard2, returnCard;
        var maxSpadeOnFloor;

        if(suit != Suits.Trump){
        	// find smallest card of led suit
        	returnCard = getMinCardBySuit(suit, this.cards);
        	if(returnCard == undefined){
        		// if small card is not there then check if someone has crossed by spade
        		maxSpadeOnFloor = this.getMaxSpadeFromFloor();
        		if(maxSpadeOnFloor != undefined){
        			// led suit card is not available and if someone has crossed card by spade then get bigger spade card than on the floor
        			returnCard = getMaxCardsThan(maxSpadeOnFloor, this.cards, true)[0];
        			if(returnCard != undefined){
//        				cc.log("player>getMinCardBySuit>returnCard: "+returnCard.suit + returnCard.value);
        			}else{
        				// if someone has crossed card by spade but no bigger spade is available then get any of the smallest card
        				if(returnCard == undefined){
        					returnCard = getMinCardBySuit(undefined, this.cards);
        				}	
        			}        			
        		}else{
        			// if noone has crossed by spade and small card of led suit is not available then get small card of any suit
        			if(hasTrump(this.cards)){
        				returnCard = getMinCardBySuit(Suits.Trump, this.cards);
        				if(returnCard == undefined){
        					returnCard = getMinCardBySuit(undefined, this.cards);
        				}
        			}else{
        				returnCard = getMinCardBySuit(undefined, this.cards);
//        				cc.log("getMinCardBySuit>returnCard: "+returnCard.suit + returnCard.value);
        			}
        		}
        	}
        }else{
        	returnCard = getMinCardBySuit(Suits.Trump, this.cards);
        }
        return returnCard;
    },
    getRandomCard:function(){
    	var refThis = this;
    	// this functions is called only when it's bot players' turn and it's first card to throw on the table/floor
    	var i, card;
    	var returnCard;
    	var randPool = [];
    	var len;
    	var maxCardSuit = getMaxCardsSuit(this.cards);
    	
    	var trumpCardsArr = getCardsBySuit(Suits.Trump, this.cards);
    	// suit with the maximum num of cards
    	var maxSuitCardsArr = getCardsBySuit(maxCardSuit, this.cards);
    	
    	// if the bot player has more than half of trump/max suit cards, then throw the smallest
    	if(trumpCardsArr.length>0 && maxSuitCardsArr.length>0)
		{	
    		if(maxSuitCardsArr.length>=Math.floor(this.cards.length/2)){
    			var rnd = Math.round(Math.random());
    			var useTrump = rnd==1?true:false;
    			var rndThrowCountMargin = getRandomNumInRange(3, 5, true);    			
    			// rndThrowCountMargin is a random margin throw count if the current throw count is greater than this number then the player must play safe, it should throw Ace or King if it has
    			var pickedSuit = useTrump == true?Suits.Trump:getRandSuit(maxSuitCardsArr);
    			// randomly using trump card if maxCardSuit is a trump suit
				if(hasAce(pickedSuit,maxSuitCardsArr))
				{    					
					if(throwCount>=rndThrowCountMargin)
					{
						returnCard = getLastMaxCardBySuit(maxSuitCardsArr, pickedSuit);
					}else {
						returnCard = getMinCardBySuit(pickedSuit, maxSuitCardsArr);
					}
				}else{
					returnCard = getMinCardBySuit(pickedSuit, maxSuitCardsArr);						
				} 
				if(returnCard == undefined){
					pickRegularRandom();
				}
    			
    		}else{
    			pickRegularRandom();
    		}
		}else{
			pickRegularRandom();	
		}
    	
    	function pickRegularRandom(){
    		len = refThis.cards.length;
    		for(i=0; i<len; i++) {
    			card = refThis.cards[i];
    			if(card.value<8){
    				randPool.push(card);
    			}
    		}
    		//    	cc.log("getRandomCard.length: "+randPool.length);
    		var r;
    		if(randPool.length>0){
    			r = getRandomNum(randPool.length, true);
    			returnCard = randPool[r];
    		}else{
    			r = getRandomNum(refThis.cards.length, true);
    			returnCard = refThis.cards[r];
    		}
    	}
    	cc.log("getRandomCard: "+returnCard.value +" "+ returnCard.suit);
        return returnCard;
    },
    getMaxSpadeFromFloor:function(){
        var i, card;

        var returnCard;
        var spadesPool = [];
        var len = cardsOnFloor.length
        for(i=0; i<len; i++) {
            card = cardsOnFloor[i];
            if(card.suit == Suits.Trump){
                spadesPool.push(card);
            }
        }
        //-------------------------------------
        if(spadesPool.length>1){
            var maxCard = spadesPool[0];
            len = spadesPool.length;
            for(i=0; i<len; i++) {
                card = cardsOnFloor[i];
                if(card.value>maxCard.value){
                    returnCard = card;
                }
            }
        }else{
            returnCard = spadesPool[0];
        }
        return returnCard;
    },
    getEstimatedBid:function(){
    	var returnVal, card, bidCount=0, i;
    	var len = this.cards.length;
    	for(i=0; i<len; i++) 
    	{
    		card = this.cards[i];
    		if(card.suit == Suits.Trump){
    			if(card.value>8){
    				bidCount++;
    			}
    		}else{
    			if(card.value>=10){
    				bidCount++;
    			}
    		}
    	}
    	
    	if(bidCount>2 && bidCount<=4){
    		bidCount = Math.ceil(bidCount*0.9);
    	}else if(bidCount>4 && bidCount<=6){
    		bidCount = Math.ceil(bidCount*0.85);
    	}else if(bidCount>6){
    		bidCount = Math.ceil(bidCount*0.8);
    	}
    	
    	if(bidCount == 0){
    		bidCount = 1;
    	}
    	returnVal = bidCount;
    	return returnVal;
    }
});