/**
 * Created by Jeevan on 10/12/14.
 */
function getRandomNumInRange (min, max, isInt) {
    var r = Math.random() * (max - min) + min;
    if(isInt){
        r = Math.floor(r);
    }
    return r;
}

function getRandomNum(num, isInt) {
	
    var r =  Math.random() * num;
    if(isInt){
       r = Math.floor(r);
    }
//    cc.log("getRandomNum "+num + " "+ r);
    return r;
}

function sortCardsArr(arr){
    arr.sort(function(a, b) {
        if (a.suit < b.suit) {
            return 1;
        }
        if (a.suit > b.suit) {
            return -1;
        }

        if (a.value < b.value) {
            return 1;
        }
        if (a.value > b.value) {
            return -1;
        }
        return 0;
    });
}

function randomizeArr(arr){
    arr.sort(function() { return 0.5 - Math.random() });
}

function getMinValCard (array) {
	var i,minCard, minCard = array[0], len = array.length;
	for (i=0; i<len; i++) {
        if (array[i].value<minCard.value) {
            minCard = array[i];
        }
    }
    return minCard;
};

function getRandSuit (array) {
	var i, suitArr = [], len = array.length;
	for (i=0; i<len; i++) {
		suitArr.push(array[i].suit);
	}
	var randVal = getRandomNum(suitArr.length, true);	
	var suit = suitArr[randVal]; 
	return suit;
};


function getRandNumberCard (array) {
	var i,returnCard;
	var tmpArr = [];
	var len = array.length;
	for (i=0; i<len; i++) {
		if (array[i].value<=8) {
			tmpArr.push(array[i]);
		}
	}	
	var randVal = getRandomNum(tmpArr.length, true);	
	returnCard = tmpArr[randVal]; 
	return returnCard;
};


function hasTrump(arr){
	var returnVal = false;
	var _card, len = arr.length;
	for(i=0; i<len; i++){
		_card = arr[i];
		if(_card.suit == Suits.Trump){
			returnVal = true;
			break;
		}
	}
	return returnVal;
}

function hasSuits(suit,arr){
	var returnVal = false;
	var _card, len = arr.length;
	for(i=0; i<len; i++){
		_card = arr[i];
		if(_card.suit == suit){
			returnVal = true;
			break;
		}
	}
	return returnVal;
}

function getMinCardBySuit(suit, arr){
	var i, card, len = arr.length;
	var minCard;
	var returnCard;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(suit!=undefined){
			if(card.suit == suit){
				if(minCard == undefined){
					minCard = card;
				}
				// just greater value card than from the current card on the floor
				if (card.value < minCard.value  ) {
					minCard = card;
				}
			}
		}else{
			if(card.suit != Suits.Trump){
				if(minCard == undefined){
					minCard = card;
				}
				// just greater value card than from the current card on the floor
				if (card.value < minCard.value  ) {
					minCard = card;
				}
			}
		}
	}
	returnCard = minCard;
	return returnCard;
}


function hasAce(suit, arr){
//	cc.log("getLastMaxCardBySuit");
//	suit = 1;
//	arr = [{suit:0,value:5},{suit:1,value:10},{suit:1,value:5},{suit:1,value:12},{suit:1,value:9},{suit:3,value:12},{suit:2,value:5},{suit:1,value:11}];
	var i, card, len = arr.length;
	var hasAce = false;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			if(card.value == 12){
				hasAce = true;
				break;
			}
		}		
	}
	return hasAce;
}

function hasCard(suit, value, arr){
//	cc.log("getLastMaxCardBySuit");
//	suit = 1;
//	arr = [{suit:0,value:5},{suit:1,value:10},{suit:1,value:5},{suit:1,value:12},{suit:1,value:9},{suit:3,value:12},{suit:2,value:5},{suit:1,value:11}];
	var i,j, card, len = arr.length;
	var yes = false;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			if(card.value == value){
				yes = true;
				break;
			}
		}		
	}
	return yes;
}

function hasFaceCards(suit, arr){
//	cc.log("hasFaceCards");
//	suit = 1;
//	arr = [{suit:0,value:5},{suit:1,value:10},{suit:1,value:5},{suit:1,value:12},{suit:1,value:9},{suit:3,value:12},{suit:2,value:5},{suit:1,value:11}];
	var i, card, len = arr.length;
	var hasFace = false;
	var count = 0;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			if(card.value>=9 && card.value<=11){
				count++;				
			}
		}		
	}
	if(count>1){
		hasFace = true;
	}
	return hasFace;
}


function getLastMaxCardBySuit(suit, arr){
//	cc.log("getLastMaxCardBySuit");
//	suit = 1;
//	arr = [{suit:0,value:5},{suit:1,value:10},{suit:1,value:5},{suit:1,value:12},{suit:1,value:9},{suit:3,value:12},{suit:2,value:5},{suit:1,value:11}];
	// sorting cards of current suit
	var suitCardArr = [];
	
	var i, card, len = arr.length;
	var hasAce = false;
	var returnCard;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			suitCardArr.push(card);
			if(card.value == 12){
				hasAce = true;
			}
		}		
	}
	
	sortCardsArr(suitCardArr);
	
//	cc.log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~getLastMaxCardBySuit>suitCardArr: "+ suitCardArr);
	len = suitCardArr.length;
	for(i=0; i<len; i++) {
		card = suitCardArr[i];
//		cc.log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~getLastMaxCardBySuit>card: "+card.value);
	}
	
	//---- finding the last max card -----
	var maxCard;
	if(hasAce){
		maxCard = suitCardArr[0];
//		cc.log("getLastMaxCardBySuit>maxCard: "+maxCard.value);
		len = suitCardArr.length;
		for(i=1; i<len; i++) {
			card = suitCardArr[i];
			
			if((card.value+1) == maxCard.value){
//				cc.log("getLastMaxCardBySuit>maxCard: "+card.value + " "+maxCard.value);
				maxCard = card;
			}
		}
		returnCard = maxCard;
	}
	//------------------------------------
//	if(returnCard!=undefined){
//		cc.log("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~getLastMaxCardBySuit>returnCard: "+ returnCard.value + " hasAce: "+hasAce );
//	}
	return returnCard;
}

function getMaxCardsThan(maxCard, __arr, oneItemOnly){
	var i, card, len;
	var returnArr = [];
	
	var arr = __arr.slice(0);
	arr.reverse();
	
	if(maxCard!=undefined){
		if(oneItemOnly == undefined){
			oneItemOnly = false;
		}
		len = arr.length;
		for(i=0; i<len; i++) {
			card = arr[i];
			if(card.suit == maxCard.suit){
				// just greater value card than from the current card on the floor
//				cc.log("getMaxCardsThan>card.value: " + card.value + " / "+ maxCard.value);
				if (card.value > maxCard.value  ) {
					maxCard = card;
					returnArr.push(maxCard);
					if(oneItemOnly){
						break;
					}
				}		
			}		
		}
	}
//	cc.log("getMaxCardsThan>oneItemOnly: "+ oneItemOnly + " returnArr.length: " + returnArr.length);
	return returnArr;
}

function getCardsBySuit(suit, arr){
	var i, card, len = arr.length;
	var returnArr = [];
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			returnArr.push(card);
		}		
	}
	return returnArr;
}

function containsCardInArr(pcard, arr){
	var i, card, len = arr.length;
	var returnVal = false;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(pcard == card){
			returnVal = true;
			break;
		}		
	}
	return returnVal;
}

function resolveScore(num) {
	return Math.round(num *10)/10;
}

function getMaxCardBySuit(suit, arr){
	var i, card, len = arr.length;;
	var maxCard;
	var returnCard;
	for(i=0; i<len; i++) {
		card = arr[i];
		if(card.suit == suit){
			if(maxCard == undefined){
				maxCard = card;
			}
			// just greater value card than from the current card on the floor
			if (card.value > maxCard.value  ) {
				maxCard = card;
			}		
		}		
	}
	returnCard = maxCard;
	return returnCard;
}

function getMaxCardsSuit(arr){
	// finds suit with maximum number of cards
	var i;
	var returnVal;
	var cardsNumArr = [];
	for(i=0; i<4; i++) {
		cardsNumArr.push(getCardsBySuit(i, arr).length);				
	}		
	returnVal = getMaxValIndex(cardsNumArr);
	return returnVal;
}

function getMaxValIndex(arr){
	var i, max = arr[0], len = arr.length;
	var returnIndex =0;
	for(i=0; i<len; i++) {
		// just greater value card than from the current card on the floor
		if (arr[i] > max ) {
			max = arr[i];
			returnIndex = i;
		}		
	}
	return returnIndex;
}

function getSizeByScale(_card, scaleVal){
	return {width:scaleVal*_card.getContentSize().width, height:scaleVal*_card.getContentSize().height};
}

function scaleTofillScreen(imgSprite){
	var scrRatio = winSize.width/winSize.height;
	var bgRatio = imgSprite.getContentSize().width/imgSprite.getContentSize().height;

	if(scrRatio<bgRatio){
		imgSprite.setScale(winSize.height/imgSprite.getContentSize().height);
	}else{
		imgSprite.setScale(winSize.width/imgSprite.getContentSize().width);
	}
}

function subtractArr(myArray, toRemove){
	var returnArr = myArray.splice(0);
	var i,j;
	for( i =returnArr.length - 1; i>=0; i--){
		for( j=0; j<toRemove.length; j++){
			if(returnArr[i] === toRemove[j]){
				returnArr.splice(i, 1);
			}
		}
	}
	return returnArr;
}


function updateSpeedVal(){
	gamePlaySpeed = 1-__gamePlaySpeed;
	tweenSpeed = 1*gamePlaySpeed;
	timeoutTime = 1000*gamePlaySpeed;
	showCardsTill = (tweenSpeed*1000) + timeoutTime*2;

	var speedVal;
	
//	cc.log("++++++++++++ updateSpeedVal> __gamePlaySpeed: "+Number(__gamePlaySpeed)  + " speedVals.low "+ speedVals.slow + " speedVals.normal "+ speedVals.normal + " speedVals.high "+ speedVals.high);
//	cc.log("++++++++++++ updateSpeedVal> __gamePlaySpeed: "+Number(__gamePlaySpeed)  + " speedVals.low "+ speedVals.slow);
	
	if((__gamePlaySpeed) == speedVals.slow){
		speedVal = 0;
	}else if((__gamePlaySpeed) == speedVals.normal){
		speedVal = 1;
	}else if((__gamePlaySpeed) == speedVals.high){
		speedVal = 2;
	}
	
//	cc.log("------------- updateSpeedVal>speedVal: "+speedVal + " __gamePlaySpeed: "+__gamePlaySpeed  + " speedVals.low "+ speedVals.slow);
	ls.setItem(Settings.gamePlaySpeed, String(speedVal));
//	cc.log("ls saving __gamePlaySpeed: " +__gamePlaySpeed);
}

function saveGameState()
{	
	//saving cards each player have 
	var i,j,player,card,len;
	var dataStr="";
	var pData = "";
	cc.log("saveGameState>playersArr: "+ playersArr.length);
	for ( i = 0; i < 4; i++) {
		player = playersArr[i];
		pData = "";
		len = player.cards.length;
		for ( j = 0; j < len; j++) {
			card = player.cards[j];
			if(j==player.cards.length-1){
				pData+=card.suit+"-"+card.value;	
			}else{
				pData+=card.suit+"-"+card.value+":";
			}						
		}
//		cc.log(" saveGameState: "+pData);
		if(i==3){
			dataStr+=pData;	
		}else{
			dataStr+=pData+"|";			
		}				
	}
	
	dataStr+="~";	
	//saving cards thrown on the floor 
	var tmpData = "";
	len = cardsOnFloor.length;
	for ( i = 0; i < len; i++) {
		card = cardsOnFloor[i];
		if(i==cardsOnFloor.length-1){
			tmpData+=card.suit+"-"+card.value+"-"+card.pid;	
		}else{
			tmpData+=card.suit+"-"+card.value+"-"+card.pid+":";
		}				
	}
	dataStr+=tmpData;	
		
	//saving each player's bid value; 
	dataStr+="~";	
	for ( i = 0; i < 4; i++) {
		player = playersArr[i];
		pData = player.bidVal;
		if(player.bidVal!=null )
		{
			pData = player.hands+"-"+player.bidVal;
		}
		if(i==3){
			dataStr+=pData;	
		}else{
			dataStr+=pData+":";			
		}				
	}	
	
	//saving current scores
	dataStr+="~";	
	dataStr+=scoreDataStr;
	
	//saving current turnCount 
	dataStr+="~";	
	dataStr+=turnCount;	

	//saving current throwCount
	dataStr+="~";	
	dataStr+=throwCount;
	
	//saving current roundCount
	dataStr+="~";	
	dataStr+=roundCount;

	ls.setItem("gameState", dataStr);
//	cc.log(" saveGameState: "+dataStr);
}

function loadSettings()
{
	//--------reading saved settings/datas -------
	//Handle for quick access to Cocos2D's implementation of Local Storage:
	ls = cc.sys.localStorage;
	
//	ls.setItem(Settings.soundEffect, "1");
//	ls.setItem(Settings.showHint,"1");
//	ls.setItem(Settings.mustHaveTrump, "1");
//	ls.setItem(Settings.mustHaveFaceCard, "1");
//	ls.setItem(Settings.animateCardDeal, "1");
//	ls.setItem(Settings.gamePlaySpeed, "1");
	
	cc.log("loadSettings>ls.getItem(Settings.customized): "+ ls.getItem(Settings.customized));
	
	var __speed;
	
	if(ls.getItem(Settings.customized) == "customized")
	{
		playSfx = ls.getItem(Settings.soundEffect) =="1"?true:false;
		showHint = ls.getItem(Settings.showHint) =="1"?true:false;
		mustHaveTrump = ls.getItem(Settings.mustHaveTrump) =="1"?true:false;
		mustHaveFaceCard = ls.getItem(Settings.mustHaveFaceCard) =="1"?true:false;
//		animateCardsDeal = ls.getItem(Settings.animateCardDeal) =="1"?true:false;
		tapToClearFloor = ls.getItem(Settings.tapToClearFloor) =="1"?true:false;
		Suits.Trump = Number(ls.getItem(Settings.trumpCard));
		__speed = Number(ls.getItem(Settings.gamePlaySpeed));
		tapToThrow = ls.getItem(Settings.tapToThrow) =="1"?true:false;
		roundNum = Number(ls.getItem(Settings.roundNum));
	}else{
		ls.setItem(Settings.soundEffect, "1");
		ls.setItem(Settings.showHint, "1");
		ls.setItem(Settings.mustHaveTrump, "1");
		ls.setItem(Settings.mustHaveFaceCard, "1");
		ls.setItem(Settings.tapToClearFloor, "0");
		ls.setItem(Settings.trumpCard, "3");
		ls.setItem(Settings.gamePlaySpeed, "1");
		ls.setItem(Settings.tapToThrow, "1");
		ls.setItem(Settings.roundNum, "5");
		
		playSfx = true;
		showHint = true
		mustHaveTrump = true;
		mustHaveFaceCard = true;
		tapToClearFloor = false;
		__speed = 1;
		tapToThrow = true;
		roundNum = 5;
	}
//	cc.log("loadsettings>_speed ", __speed);
	
	if(__speed == 0){
		__gamePlaySpeed = speedVals.slow;
	}else if(__speed == 1){
		__gamePlaySpeed = speedVals.normal;
	}else if(__speed == 2){
		__gamePlaySpeed = speedVals.high;
	}
//	cc.log("loadsettings>__gamePlaySpeed ", __gamePlaySpeed);
	
//	if(__gamePlaySpeed == undefined || __gamePlaySpeed ==""){
//		__gamePlaySpeed = speedVals.normal;
//	}
	
	updateSpeedVal();
	
//	cc.log("loadSettings>playSfx: "+ playSfx + " showHint: "+showHint+ " mustHaveTrump: "+ mustHaveTrump+ " mustHaveFaceCard: "+ mustHaveFaceCard +" animateCardsDeal: "+ animateCardsDeal+ " __gamePlaySpeed: "+ __gamePlaySpeed + " tapToThrow: "+tapToThrow+ " roundNum: "+roundNum);

	curBgImgIndx = Number(ls.getItem(Settings.bgImg));
	if(curBgImgIndx>tableBgImgArr.length-1)
	{
		curBgImgIndx = 0;
	}
	curCardBackImgIndx = Number(ls.getItem(Settings.cardBackImg));
	if(curCardBackImgIndx>cardBackImgArr.length-1)
	{
		curCardBackImgIndx = 0;
	}
}

