/**
 * Created by user on 10/14/14.
 */
var StatusLayer = cc.Layer.extend({
    namesArr:null,
    callLabelsArr:null,
    labelsArr:null,
    posArr:null,
    roundLabel:null,
    curSuitLabel:null, 
    trumpSuitLabel:null,
    trumpSuitIconLabel:null,
    suitsArr:null,
    scaleVals:null,
    ctor:function () {
        this._super();
//        this.scheduleOnce(this.init, 0.5);
        this.init();
        return true;
    },
    init:function(){
    	var marginH = 40, marginV = 50;

    	if(isDebugMode){
    		this.posArr = [cc.p(visibleSize.width/2,178),cc.p(visibleSize.width-153,visibleSize.height/2),cc.p(visibleSize.width/2,visibleSize.height-170),cc.p(153,visibleSize.height/2)];
    	}else{
    		this.posArr = [cc.p(visibleSize.width/2,165),
    		               cc.p(visibleSize.width-marginH,visibleSize.height/2 + marginV),
    		               cc.p(visibleSize.width/2-marginH*1.6,btnYpos+14),
    		               cc.p(marginH,visibleSize.height/2 + marginV)];
    	}

    	this.labelsArr = [];
    	this.nameLabel = [];
    	this.scaleVals = {normal:0.8,scaled:1.2};
    	var i, callLabel, handLabel, nameLabel, bgRect, pos;

    	for(i=0;i<4;i++){
//  		callLabel = new cc.LabelTTF(this.namesArr[i]+" C: 0", boldFont, 16);
    		bgRect = new cc.Sprite(res.rect2Img);
    		callLabel = new cc.LabelTTF("0", boldFont, 30);
    		handLabel = new cc.LabelTTF("0", boldFont, 30);
    		nameLabel = new cc.LabelTTF(playersNameArr[i], boldFont, 36);
    		nameLabel.setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)

    		callLabel.setAnchorPoint(0.5,0.4);
    		handLabel.setAnchorPoint(0.5,0.4);
    		nameLabel.setAnchorPoint(0.5,0.4);

    		callLabel.setScale(this.scaleVals.normal);
    		handLabel.setScale(this.scaleVals.normal);
//    		nameLabel.setScale(this.scaleVals.normal);
    		
    		bgRect.setPosition(this.posArr[i]);

    		handLabel.setPosition(cc.p(bgRect.getPositionX()-14, bgRect.getPositionY()));
    		callLabel.setPosition(cc.p(bgRect.getPositionX()+14, bgRect.getPositionY()));
    		
    		if(i == 0){
    			nameLabel.setPosition(cc.p(bgRect.getPositionX()-(nameLabel.getContentSize().width+bgRect.getContentSize().width/2), bgRect.getPositionY()));
    		}else if(i == 1){
    			nameLabel.setPosition(cc.p(bgRect.getPositionX(), bgRect.getPositionY()+35));
    		}else if(i == 2){
    			nameLabel.setPosition(cc.p(bgRect.getPositionX()-(nameLabel.getContentSize().width+bgRect.getContentSize().width/2), bgRect.getPositionY()));
    		}else if(i == 3){
    			nameLabel.setPosition(cc.p(bgRect.getPositionX(), bgRect.getPositionY()+35));
    		}
    		
    		this.addChild(bgRect);
    		this.addChild(callLabel);
    		this.addChild(handLabel);
    		this.addChild(nameLabel);

    		this.labelsArr.push({callLabel:callLabel,handLabel:handLabel, nameLabel:nameLabel, bgRect:bgRect});
    	}
    	
    	this.suitsArr = [" ","♦","♣","♥","♠"];

    	this.roundLabel = new cc.LabelTTF("Round: 1", boldFont, 28);
    	this.roundLabel.setAnchorPoint(0,0);
    	
    	this.roundLabel.attr({
    		x:140,
    		y:btnYpos
    	});

    	this.trumpSuitLabel = new cc.LabelTTF("Trump: ", boldFont, 28);
    	this.trumpSuitLabel.setAnchorPoint(0,0);
    	this.trumpSuitLabel.attr({
    		x:140,
    		y:btnYpos-45
    	});

//    	"♦","♣","♥","♠"
    	this.trumpSuitIconLabel = new cc.LabelTTF("", boldFont, 45);
    	this.trumpSuitIconLabel.setAnchorPoint(0,0);
    	this.trumpSuitIconLabel.attr({
    		x:230,
            y:btnYpos-55
    	});
    	
    	this.curSuitLabel = new cc.LabelTTF("Suit: ", boldFont, 28);
    	this.curSuitLabel.setAnchorPoint(0,0);
    	this.curSuitLabel.attr({
    		x:visibleSize.width/2+60,
    		y:btnYpos
    	});

    	this.suitIconLabel = new cc.LabelTTF(" ", boldFont, 45);
    	this.suitIconLabel.setAnchorPoint(0,0);
    	this.suitIconLabel.attr({
    		x:this.curSuitLabel.getPositionX()+this.curSuitLabel.getContentSize().width,
            y:btnYpos-20
    	});

    	this.addChild(this.curSuitLabel);
    	this.addChild(this.suitIconLabel);
    	this.addChild(this.roundLabel);

    	this.addChild(this.trumpSuitLabel);
    	this.addChild(this.trumpSuitIconLabel);
    },
    setCalls:function(){    	
    	var val = playersArr[callTurnCount].bidVal;
//    	cc.log("setCalls "+val);
        var label = this.labelsArr[callTurnCount].callLabel;
        if(label!=undefined)
        {
        	label.setString(val);	
        }        
        this.popUp(label);
        this.popUp(this.labelsArr[callTurnCount].nameLabel);
    },
    setHands:function(val){
    	var label = this.labelsArr[turnCount].handLabel;
    	label.setString(val);
    	this.popUp(label);
    	this.popUp(this.labelsArr[callTurnCount].nameLabel);
    },
    popUp:function (tar){
    	var seq = new cc.Sequence(
    			new cc.ScaleTo(0.25,this.scaleVals.scaled),
    			new cc.DelayTime(0.5),
    			new cc.ScaleTo(0.25,this.scaleVals.normal));
    	
    	tar.runAction(new cc.Repeat(seq,2));
    },
    setRound:function(val){
    	this.roundLabel.setString("Round: "+ val +"/"+ roundNum);
    },
    setCurSuit:function(val){
    	this.suitIconLabel.setString(this.suitsArr[val+1]);
    },
    setTrump:function(val){
    	this.trumpSuitIconLabel.setString(this.suitsArr[val+1]);
    },
    updateInfo:function()
    {
    	for(var i=0;i<this.labelsArr.length;i++){
    		this.labelsArr[i].callLabel.setString(playersArr[i].bidVal);
    		this.labelsArr[i].handLabel.setString(playersArr[i].hands);
    	}
    	this.roundLabel.setString("Round: "+ roundCount);
    	if(curCardMove != undefined)
    	{
    		this.suitIconLabel.setString(this.suitsArr[curCardMove.suit]);
		}
    }
});